﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading;

namespace JMSAdapterBindingNamespace
{   
    public class FaultTolerantService
    {
        public static ServiceHost theServiceHost = null;
        public int pollingPeriod = 3000;  // 3 seconds

        public void connect(Object singleAttempt)
        {
            bool notConnected = true;
            while (notConnected == true)
            {
                if (theServiceHost == null || theServiceHost.State == CommunicationState.Closed || theServiceHost.State == CommunicationState.Faulted)
                {
                    theServiceHost = new ServiceHost(typeof(JMSAdapterBindingService));
                }
                try
                {
                    theServiceHost.Open();
                }
                catch(Exception ex)
                {
                    Console.WriteLine("Unable to connect to the JMS server with exception: " + ex.Message);
                    if ((bool)singleAttempt == true)
                    {
                        break;
                    }
                    Thread.Sleep(this.pollingPeriod);
                    continue;
                }
                theServiceHost.Closed += new EventHandler(this.onClosed);
                notConnected = false;
                Console.WriteLine("Connected to JMS server");
            }
        }

        public void onClosed(object sender, EventArgs args)
        {
            ThreadPool.QueueUserWorkItem(this.connect, false);
        }

    }

    class Program
    {
        static void Main(string[] args)
        {
            FaultTolerantService aService = new FaultTolerantService();
            aService.pollingPeriod = 15000;
            aService.connect(true);
            // block termination
            Console.ReadLine();
        }
    }
}
